;******************************************************************************************
;    PROGRAMME	:  Affiche.asm				
;    PROGRAMME ATTACHE : Regul.asm
;******************************************************************************************


;******************************************************************************************
;			Affichage des valeurs sur LCD
;******************************************************************************************
;	L'affichage se fait en fonction de :
;
;	N de page
;	Rgulation En ou Hors Service
;	Bruleur Autoris ou Non
;	Tempratures et valeurs stocks (Tambiant, cdc,...., niveau fuel,...)
;
;	Registres Modifies : SREG
;******************************************************************************************
Aff_Valeurs:
	push zl
	push zh
	push r16
	
	mov r16,DRAPEAUX
	andi r16,0x03			; Lecture du n de page
	breq Aff_Normal		; Si 0 : Mode Normal
	cpi r16,0x01
	breq Aff_Horl			; Horloge
	cpi r16,0x02
	breq Fin_Aff_Valeurs_BIS		; Pas de valeur en page mode
	rjmp Aff_Temps			; Page affichage des temps

Fin_Aff_Valeurs_BIS: rjmp Fin_Aff_Valeurs
	
;--------------------- Page 0 : Mode Normal -----------------------------------------------	
Aff_Normal:
	sbrs DRAPEAUX,2			; Regulation  l'arrt ?
	rjmp Aff_Arret			; Oui va  la page arrt
	
	sbrs DRAPEAUX,3			; Bruleur en repos ?
	rjmp Aff_Repos			; Oui va  repos	

	sbrc DRAPEAU2,4		; Saut si mode auto
	rjmp TC			; Sinon n'affiche pas la consigne ambiante

	ldi r16,0x8C
	rcall PROG_LCD		; Place curseur
	lds r16,Cons_Amb
	rcall Aff_Temp_Decimal	; Affiche consigne Ambiante

TC:
	sbrs DRAPEAU2,1		; Saut si Moyenne calcule (au bout de 32s)
	rjmp TC2		; Sinon n'affiche pas la Temp Ambiante

	ldi r16,0x84
	rcall PROG_LCD		; Place curseur
	lds r16,L_Temp_Amb
	rcall Aff_Temp_Decimal	; Affiche temprature Ambiante

TC2:
	ldi r16,0xC4
	rcall PROG_LCD		; Place curseur
	lds r16,L_Temp_Cdc
	rcall Aff_Temp_Decimal	; Affiche temprature corps de chauffe

	ldi r16,0xCC
	rcall PROG_LCD		; Place curseur
	lds r16,Cons_Cdc
	rcall Aff_Temp_Decimal	; Affiche consigne corps de chauffe
	rjmp Fin_Aff_Ecran

Aff_Repos:	
	sbrs DRAPEAU2,1		; Saut si Moyenne calcule (au bout de 32s)
	rjmp TC3		; Sinon n'affiche pas la temprature ambiante

	ldi r16,0x84
	rcall PROG_LCD		; Place curseur
	lds r16,L_Temp_Amb
	rcall Aff_Temp_Decimal	; Affiche temprature Ambiante
TC3:
	ldi r16,0x8C
	rcall PROG_LCD		; Place curseur
	lds r16,Cons_Amb
	rcall Aff_Temp_Decimal	; Affiche consigne Ambiante
	rjmp Fin_Aff_Ecran

Aff_Arret:
	sbrs DRAPEAU2,1		; Saut si Moyenne calcule (au bout de 32s)
	rjmp Fin_Aff_Valeurs	; Sinon n'affiche rien

	ldi r16,0x8C
	rcall PROG_LCD		; Place curseur
	lds r16,L_Temp_Amb
	rcall Aff_Temp_Decimal	; Affiche temprature Ambiante
	rjmp Fin_Aff_Valeurs

;--------------------- Page 1 : Mode Horlogerie -------------------------------------------	
Aff_Horl:

	rjmp Fin_Aff_Valeurs

;--------------------- Page 2 : Page Mode ---------------------------------------------	
; Rien ne se fait ici

;--------------------- Page 3 : Page Temps ---------------------------------------------------	
Aff_Temps:
	ldi r16,0x87
	rcall PROG_LCD
	lds r16,Tps_Bruleur
	rcall Aff_Dec
	ldi r16,0x8A
	rcall PROG_LCD
	lds r16,Tps_Bruleur+1
	rcall Aff_Dec
	ldi r16,0x8D
	rcall PROG_LCD
	lds r16,Tps_Bruleur+2
	rcall Aff_Dec

	ldi r16,0xC8
	rcall PROG_LCD
	lds r16,Tps_Repos
	rcall Aff_Dec
	ldi r16,0xCA
	rcall PROG_LCD
	lds r16,Tps_Repos+1
	rcall Aff_Dec
	ldi r16,0xCD
	rcall PROG_LCD
	lds r16,Tps_Repos+2
	rcall Aff_Dec



Fin_Aff_Valeurs:
	pop r16
	pop zh
	pop zl
	ret

;******************************************************************************************
;			SP: Affichage d'un chiffre en dcimal 2 digits
;******************************************************************************************
;	A afficher un chiffre en dcimal 2 digits (00  99). Il faut positionner le curseur
;	de l'afficheur  l'endroit opu afficher avant de lancer la fonction.
;
;	Entres : r16 (Chiffre  traduire)
;	Sorties : Aucunes
;
;	Registres Modifies : SREG
;******************************************************************************************
Aff_Dec:
	push r17
	push r18
	push r19
	
	ldi r19,'0'
	
	mov r17,r16
	lsr r17
	lsr r17
	lsr r17
	lsr r17
	add r17,r19		; Pasage des dizaines en ascci

	mov r18,r16
	andi r18,0x0F
	add r18,r19

	mov r16,r17
	rcall DATA_LCD		; Affiche dizaines	
	mov r16,r18
	rcall DATA_LCD		; Affiche les units

	pop r19
	pop r18
	pop r17
	ret

;******************************************************************************************
;			Affichage l'Ecran LCD
;******************************************************************************************
;	L'affichage se fait en fonction de :
;
;	N de page
;	Rgulation En ou Hors Service
;	Bruleur Autoris ou Non
;
;	Registres Modifies : SREG
;******************************************************************************************
Aff_Ecran:
	push zl
	push zh
	push r16
	
	mov r16,DRAPEAUX
	andi r16,0x03			; Lecture du n de page
	breq Page_Normal		; Si 0 : Mode Normal
	cpi r16,0x01
	breq Page_Horl			; Jauge  Fuel
	cpi r16,0x02
	breq Page_Mode			; Mode de fonctionnement
	rjmp Page_Temps			; Prog Modem
	
;--------------------- Page 0 : Mode Normal -----------------------------------------------	
Page_Normal:
	sbrs DRAPEAUX,2			; Regulation  l'arrt ?
	rjmp Page_Arret			; Oui va  la page arrt
	
	sbrs DRAPEAUX,3			; Bruleur en repos ?
	rjmp Repos			; Oui va  repos	

	sbrs DRAPEAU2,4			; Saut si mode auto
	rjmp Mauto			; Sinon Affiche mode manuel

	ldi zl,low(NORMAL10*2)		; Afficher la ligne 1 Ecran
	ldi zh,high(NORMAL10*2)	
	rcall Aff_Lg1
	rjmp Mlg2
Mauto:
	ldi zl,low(NORMAL11*2)		; Afficher la ligne 1 Ecran
	ldi zh,high(NORMAL11*2)	
	rcall Aff_Lg1

Mlg2:
	ldi zl,low(NORMAL2*2)		; Afficher la ligne 2 Ecran
	ldi zh,high(NORMAL2*2)	
	rcall Aff_Lg2
	rjmp Fin_Aff_Ecran

Repos:
	ldi zl,low(NORMAL11*2)		; Afficher la ligne 1 Ecran
	ldi zh,high(NORMAL11*2)	
	rcall Aff_Lg1

	ldi zl,low(REPOS2*2)		; Afficher la ligne 2 Ecran
	ldi zh,high(REPOS2*2)	
	rcall Aff_Lg2
	rjmp Fin_Aff_Ecran

Page_Arret:
	ldi zl,low(ARRET1*2)		; Afficher la ligne 1 Ecran
	ldi zh,high(ARRET1*2)	
	rcall Aff_Lg1

	ldi zl,low(ARRET2*2)		; Afficher la ligne 2 Ecran
	ldi zh,high(ARRET2*2)	
	rcall Aff_Lg2
	rjmp Fin_Aff_Ecran

;--------------------- Page 1 : Mode Horlogerie -------------------------------------------	
Page_Horl:
	ldi zl,low(HORLO1*2)		; Afficher la ligne 1 Ecran
	ldi zh,high(HORLO1*2)	
	rcall Aff_Lg1

	ldi zl,low(HORLO2*2)		; Afficher la ligne 2 Ecran
	ldi zh,high(HORLO2*2)	
	rcall Aff_Lg2
	rjmp Fin_Aff_Ecran

;--------------------- Page 2 : Mode Timer ---------------------------------------------	
Page_Mode:
	ldi zl,low(MODE1*2)		; Afficher la ligne 1 Ecran
	ldi zh,high(MODE1*2)	
	rcall Aff_Lg1
	
	sbrs DRAPEAU2,4			; Si mode manuel saut
	rjmp Pauto			; sinon mode automatique

	ldi zl,low(MODE20*2)		; Afficher la ligne 2 Ecran
	ldi zh,high(MODE20*2)	
	rcall Aff_Lg2
	rjmp Fin_Aff_Ecran

Pauto:
	ldi zl,low(MODE21*2)		; Afficher la ligne 2 Ecran
	ldi zh,high(MODE21*2)	
	rcall Aff_Lg2
	rjmp Fin_Aff_Ecran

;--------------------- Page 3 : Mode Affich. Temps -------------------------------------------	
Page_Temps:
	ldi zl,low(TEMPS1*2)		; Afficher la ligne 1 Ecran
	ldi zh,high(TEMPS1*2)	
	rcall Aff_Lg1

	ldi zl,low(TEMPS2*2)		; Afficher la ligne 2 Ecran
	ldi zh,high(TEMPS2*2)
	rcall Aff_Lg2

Fin_Aff_Ecran:
	sbrs DRAPEAUX,4			; Si mode test saut
	rjmp Pas_Test			; Sinon va  Pas_Test
	
	ldi r16,0x80
	rcall PROG_LCD			; Curseur  0
	ldi r16,0xFF
	rcall DATA_LCD			; Affiche un pav pour indiquer le mode test

Pas_test:
	pop r16
	pop zh
	pop zl
	ret


;******************************************************************************************
;			ECRAN LCD
;******************************************************************************************
;---------------------------- Page 0 ------------------------------------------------------
NORMAL10:.db "Amb:att.        ",0  ; Mode Manuel
NORMAL11:.db "Amb:att. co:xx.x",0  ; Mode auto
NORMAL2: .db "Eau:xx.x co:xx.x",0

REPOS2:	.db "*** En Repos ***",0

ARRET1:	.db "Temperature:att.",0
ARRET2:	.db "***** Arret ****",0

;---------------------------- Page 1 ------------------------------------------------------
HORLO1:	.db "Heure: xx:xx:xx ",0
HORLO2:	.db "                ",0

;---------------------------- Page 2 ------------------------------------------------------
MODE1:	.db "***** Mode *****",0
MODE20:	.db "     Manuel     ",0
MODE21: .db "  Automatique   ",0

;---------------------------- Page 3 ------------------------------------------------------
TEMPS1:	.db "Brul.: xxhxxmxxs",0
TEMPS2:	.db "Repos:  xxxxhxxm",0
