;******************************************************************************************
;    PROGRAMME	:  clavier.asm				
;    PROGRAMME ATTACHE : Regul.asm
;******************************************************************************************


;******************************************************************************************
;			Gestion du clavier
;******************************************************************************************
;	La gestion du clavier se fait en fonction de :
;
;	N de page
;	Rgulation En ou Hors Service
;	Bruleur Autoris ou Non
;	Tempratures et valeurs stocks (Tambiant, cdc,...., niveau fuel,...)
;
;	Registres Modifies : SREG
;******************************************************************************************
;************************* Clavier utilisateur (Touches 0  3) ****************************
Gest_Clavier:
	push r16
	
	mov r16,DRAPEAUX
	andi r16,0x03			; Lecture du n de page
	breq Clav_Normal		; Si 0 : Mode Normal
	cpi r16,0x01
	breq Clav_HorloBis			; Horloge
	cpi r16,0x02
	breq Clav_ModeBis			; Page Mode
	rjmp Clav_Temps				; Prog ChronoTemps
	
Clav_HorloBis: rjmp Clav_Horlo
Clav_ModeBis: rjmp Clav_Mode

;--------------------- Page 0 : Mode Normal -----------------------------------------------	
Clav_Normal:
	sbrs DRAPEAUX,2			; Regulation  l'arrt ?
	rjmp Clav_Arret			; Oui va  la page arrt

	cpi touche,0x03			; Passage  l'arrt ?
	brne TE1
	cbr DRAPEAUX,0x04		; Mise  l'arrt
	rcall Aff_Ecran			; Affichage de l'cran
	rcall Aff_Valeurs		; Affichage des valeurs
	rjmp Fin_Gest_Clavier
TE1:	cpi Touche,0x02			; Changement de page ?
	brne TE2
	inc DRAPEAUX			; Passage en page 1
	rcall Aff_Ecran			; Affichage de l'cran
	rcall Aff_Valeurs		; Affichage des valeurs
	rjmp Fin_Gest_Clavier

TE2:	sbrc DRAPEAU2,4			; Si mode auto saut = Rglage Cons_Amb
	rjmp ManuMode			; Sinon Manuel = Rglage Cons_Cdc

	cpi touche,0x00			; Decrenter consigne ?
	brne TE3
	lds r16,Cons_Amb		; Lire consigne Ambiante
	cpi r16,30			; Mini 15C
	breq Fin_Gest_ClavierBis
	dec r16
	sts Cons_Amb,r16
	rcall Aff_Valeurs
Fin_Gest_ClavierBis:
	rjmp Fin_Gest_Clavier
TE3:	cpi touche,0x01			; Incrementer consigne ?
	brne Fin_Gest_ClavierBis
	lds r16,Cons_Amb		; Lire consigne Ambiante
	cpi r16,46			; Maxi 23C
	breq Fin_Gest_ClavierBis
	inc r16
	sts Cons_Amb,r16
	rcall Aff_Valeurs
Fin_Gest_Clavier_BIS:
	rjmp Fin_Gest_Clavier


ManuMode:
	cpi touche,0x00			; Decrenter consigne ?
	brne TE25
	lds r16,Cons_Cdc		; Lire consigne Ambiante
	cpi r16,20			; Mini 10C
	breq Fin_Gest_Clavier_BIS
	dec r16
	sts Cons_Cdc,r16
	rcall Aff_Valeurs
	rjmp Fin_Gest_Clavier
TE25:	cpi touche,0x01			; Incrementer consigne ?
	brne Fin_Gest_Clavier_BIS
	lds r16,Cons_Cdc		; Lire consigne Ambiante
	cpi r16,100			; Maxi 50C
	breq Fin_Gest_Clavier_BIS
	inc r16
	sts Cons_Cdc,r16
	rcall Aff_Valeurs
	rjmp Fin_Gest_Clavier


Clav_Arret:
	cpi touche,0x03			; Passage en marche ?
	brne TE31
	sbr DRAPEAUX,0x0C		; Mise en marche + Chauff=1
	sbr DRAPEAU2,0x0C		; Dem=1; Regl=1
	rcall Aff_Ecran			; Affichage de l'cran
	rcall Aff_Valeurs		; Affichage des valeurs
	rjmp Fin_Gest_Clavier
TE31:	cpi Touche,0x02			; Changement de page ?
	brne Fin_Gest_Clavier
	inc DRAPEAUX			; Passage en page 1
	rcall Aff_Ecran			; Affichage de l'cran
	rcall Aff_Valeurs		; Affichage des valeurs
	rjmp Fin_Gest_Clavier

;--------------------- Page 1 : Mode Horlogerie -------------------------------------------	
Clav_Horlo:
	cpi Touche,0x02			; Changement de page ?
	brne Fin_gest_Clavier
	inc DRAPEAUX			; Passage en page 2
	rcall Aff_Ecran			; Affichage de l'cran
	rcall Aff_Valeurs		; Affichage des valeurs
	rjmp Fin_Gest_Clavier

;--------------------- Page 2 : Mode ---------------------------------------------------	
Clav_Mode:
	cpi Touche,0x02			; Changement de page ?
	brne TE7
	inc DRAPEAUX			; Passage en page 3
	rcall Aff_Ecran			; Affichage de l'cran
	rcall Aff_Valeurs		; Affichage des valeurs
	rjmp Fin_Gest_Clavier
TE7:	cpi touche,0x00			; Passer en mode Manuel ?
	brne TE8
	sbr DRAPEAU2,0x10		; Passage en mode Manuel
	sbr DRAPEAUX,0x08		; Reforcer chauff  1
	rcall Aff_Ecran
	rjmp Fin_Gest_Clavier
TE8:	cpi touche,0x01			; Passer en mode Auto ?
	brne Fin_Gest_Clavier
	cbr DRAPEAU2,0x1C		; Passage en mode Auto (Dem=0; Regl=0)
	rcall Aff_Ecran
	rjmp Fin_Gest_Clavier


;--------------------- Page 3 : Mode Temps ---------------------------------------------
Clav_Temps:
	cpi Touche,0x02			; Changement de page ?
	brne CT3
	andi DRAPEAUX,0xFC		; Passage en page 0
	rcall Aff_Ecran			; Affichage de l'cran
	rcall Aff_Valeurs		; Affichage des valeurs
	rjmp Fin_Gest_Clavier

CT3:
	cpi Touche,0x03			; Raz Horodateur ?
	brne Fin_Gest_Clavier
	clr r16
	sts Tps_Bruleur,r16
	sts Tps_Bruleur+1,r16
	sts Tps_Bruleur+2,r16
	sts Tps_Repos,r16
	sts Tps_Repos+1,r16
	sts Tps_Repos+2,r16
	sts Tps_Repos+3,r16
	rcall Aff_Valeurs		; Affichage des valeurs

Fin_Gest_Clavier:

;************************* Clavier de test (Touches 4  15) *****************************
;************************* Ne dpend pas de la page en cours ****************************
Testeur:
	cpi touche,12
	brne TestOuPas			; Arret testeur ?
	cbr DRAPEAUX,0x10		; Arreter testeur 
	rcall Aff_Ecran			; Affichage du fond d'ecran
	rjmp Fin_Testeur
TestOuPas:
	cpi touche,13			; Mise en marche testeur
	brne Verif_Test
	sbr DRAPEAUX,0x10		; mettre en test
	rcall Aff_Ecran			; Affichage du fond d'ecran
	rjmp Fin_Testeur

Verif_Test:
	sbrs DRAPEAUX,4			; Saut si mode test
	rjmp Fin_Testeur		; Si pas test fin
	; ATTENTION : Pas de tests de dpassement (sauf Cons_Cdc)
	cpi touche,0x04			; Dcrementer Tamb ?
	brne TE4
	lds r16,L_Temp_Amb		
	dec r16
	sts L_Temp_Amb,r16
	rcall Aff_Valeurs
	rjmp Fin_Testeur
TE4:	cpi touche,0x05			; Incrementer Tamb ?
	brne TE5
	lds r16,L_Temp_Amb		
	inc r16
	sts L_Temp_Amb,r16
	rcall Aff_Valeurs
	rjmp Fin_Testeur
TE5:	cpi touche,0x08			; Dcrementer TCdc ?
	brne TE6
	lds r16,L_Temp_Cdc		
	dec r16 
	sts L_Temp_Cdc,r16
	rcall Aff_Valeurs
	rjmp Fin_Testeur
TE6:	cpi touche,0x09			; Incrementer TCdc ?
	brne TE1000
	lds r16,L_Temp_Cdc		
	inc r16
	sts L_Temp_Cdc,r16
	rcall Aff_Valeurs
	rjmp Fin_Testeur
TE1000:	cpi touche,0x0E			; CpTemps=0 ?
	brne TE1001
	clr CpTemps
	rcall Aff_Valeurs
	rjmp Fin_Testeur
TE1001: cpi touche,0x0F			; Totaliseur ++
	brne Fin_Testeur
	inc Totaliseur
	rcall Aff_Valeurs
	ldi r16,0xC0
	rcall PROG_LCD
	mov r16,Totaliseur
	push r17
	ldi r17,'0'
	add r16,r17
	pop r17
	rcall DATA_LCD			; Affichage Valeur Totaliseur Col0 lg1
	rjmp Fin_Testeur

Fin_Testeur:
	pop r16
	ret

